/* 
 * File:   TER876XC8.c
 * Author: Admin
 *
 * Created on 23  2024 ., 19:22
 */

#include <stdio.h>
#include <stdlib.h>

//=================================================================
// CONFIG PIC16F876A
#pragma config FOSC = HS // 
#pragma config WDTE = OFF // 
#pragma config PWRTE = ON // 
#pragma config LVP = OFF //
#pragma config DEBUG = OFF //
#pragma jis
//************************************************************************* 

//LCD 
#define LCD_RS       RB0
#define LCD_EN       RB1
#define LCD_D4       RB2
#define LCD_D5       RB3
#define LCD_D6       RB4
#define LCD_D7       RB5
#define LCD_RS_DIR   TRISB0
#define LCD_EN_DIR   TRISB1
#define LCD_D4_DIR   TRISB2
#define LCD_D5_DIR   TRISB3
#define LCD_D6_DIR   TRISB4
#define LCD_D7_DIR   TRISB5

// DS18B20  RA1
#define DS18B20_PIN      RA1
#define DS18B20_PIN_Dir  TRISA1

// DHT22  RA2
#define DHT22_PIN      RA2
#define DHT22_PIN_DIR  TRISA2

//  i2c 
#define SDA RC4 // Data 
#define SCL RC3 // Clock 
#define SDA_DIR TRISC4 // Data 
#define SCL_DIR TRISC3 // Clock 
#include <stdint.h>

#define BME280_Start    I2C_Start
#define BME280_StartR   I2C_Repeated_Start
#define BME280_Write    I2C_Write
#define BME280_Read     I2C_Read
#define BME280_Stop     I2C_Stop

 #define BME280_I2C_ADDRESS  0xEC  //236
// #define BME280_I2C_ADDRESS  0xEE  //238

#define BME280_CHIP_ID        0x60

#define BME280_REG_DIG_T1     0x88
#define BME280_REG_DIG_T2     0x8A
#define BME280_REG_DIG_T3     0x8C

#define BME280_REG_DIG_P1     0x8E
#define BME280_REG_DIG_P2     0x90
#define BME280_REG_DIG_P3     0x92
#define BME280_REG_DIG_P4     0x94
#define BME280_REG_DIG_P5     0x96
#define BME280_REG_DIG_P6     0x98
#define BME280_REG_DIG_P7     0x9A
#define BME280_REG_DIG_P8     0x9C
#define BME280_REG_DIG_P9     0x9E

#define BME280_REG_DIG_H1     0xA1
#define BME280_REG_DIG_H2     0xE1
#define BME280_REG_DIG_H3     0xE3
#define BME280_REG_DIG_H4     0xE4
#define BME280_REG_DIG_H5     0xE5
#define BME280_REG_DIG_H6     0xE7

#define BME280_REG_CHIPID     0xD0
#define BME280_REG_SOFTRESET  0xE0

#define BME280_REG_CTRLHUM    0xF2
#define BME280_REG_STATUS     0xF3
#define BME280_REG_CONTROL    0xF4
#define BME280_REG_CONFIG     0xF5
#define BME280_REG_PRESS_MSB  0xF7

int32_t adc_T, adc_P, adc_H, t_fine;
 
#include <xc.h>
#define _XTAL_FREQ 8000000
#include <stdint.h>        
#include <math.h>
#include <pic.h>
//**********************************************************************
//**********************************************************************
#pragma warning disable 520
#include <stdint.h>
#define LCD_FIRST_ROW          0x80
#define LCD_SECOND_ROW         0xC0
#define LCD_THIRD_ROW          0x94
#define LCD_FOURTH_ROW         0xD4
#define LCD_CLEAR              0x01
#define LCD_RETURN_HOME        0x02
#define LCD_ENTRY_MODE_SET     0x04
#define LCD_CURSOR_OFF         0x0C
#define LCD_UNDERLINE_ON       0x0E
#define LCD_BLINK_CURSOR_ON    0x0F
#define LCD_MOVE_CURSOR_LEFT   0x10
#define LCD_MOVE_CURSOR_RIGHT  0x14
#define LCD_TURN_ON            0x0C
#define LCD_TURN_OFF           0x08
#define LCD_SHIFT_LEFT         0x18
#define LCD_SHIFT_RIGHT        0x1E


uint8_t i2c_addr;

void I2C_Init(uint32_t i2c_clk_freq);
void I2C_Repeated_Start();
void I2C_Start();
void I2C_Stop();
void I2C_Write(uint8_t i2c_data);
uint8_t I2C_Read(uint8_t ack);

#ifndef LCD_TYPE
#define LCD_TYPE 2           // 
#endif
//**********************************************************************
//**********************************************************************
__bit RS;

//**********************************************************************
//**********************************************************************
void LCD_Write_Nibble(uint8_t n);        //
void LCD_Cmd(uint8_t Command);         //
void LCD_Goto(uint8_t col, uint8_t row);   //
void LCD_PutC( char LCD_Char);           //
void LCD_Print( char * LCD_Str);           //
void LCD_Begin();                 //
//**********************************************************************
//**********************************************************************
signed long temperature;
unsigned long pressure, pressurem, humidity;
char buffer[19] = " \xA8\x4F\xA8\x41\x50\xA5MC\xB1!       ";
 
//**********************************************************************
//*************DS18B20**************************************************
uint16_t raw_temp;
char     tempD[] = "CTEM\xA8 000.0000 C    ";
//*************DS18B20************************************************** 
//**********************************************************************

//**********************************************************************
//**************DHT22***************************************************
char TemperatureH[] = "   00.0 C";
  char HumidityH[]    = "\x43\x42\xA7\x41\xA3 00.0 %";
unsigned char T_Byte1, T_Byte2, RH_Byte1, RH_Byte2, CheckSum ;
unsigned int TempH, RH;
//**************DHT22***************************************************
//**********************************************************************
void LCD_Write_Nibble(uint8_t n)
{
  LCD_RS = RS;
  LCD_D4 = n & 0x01;
  LCD_D5 = (n >> 1) & 0x01;
  LCD_D6 = (n >> 2) & 0x01;
  LCD_D7 = (n >> 3) & 0x01;

  // enable 
  LCD_EN = 0;
  __delay_us(1);
  LCD_EN = 1;
  __delay_us(1);
  LCD_EN = 0;
  __delay_us(100);
}
//**********************************************************************
//**********************************************************************
//**********************************************************************
//**********************************************************************
void LCD_Print( char* LCD_Str)
{
  uint8_t i = 0;
  RS = 1;
  while(LCD_Str[i] != '\0')
  {
    LCD_Write_Nibble(LCD_Str[i] >> 4);
    LCD_Write_Nibble(LCD_Str[i++] );
  }
}
//**********************************************************************
//**********************************************************************

//**********************************************************************
//**********************************************************************
void LCD_PutC(char LCD_Char)
{
  RS = 1;
  LCD_Write_Nibble(LCD_Char >> 4);
  LCD_Write_Nibble(LCD_Char );
}
//**********************************************************************
//**********************************************************************
 
//**********************************************************************
//**********************************************************************
void LCD_Goto(uint8_t col, uint8_t row)
{
  switch(row)
  {
    case 1:
      LCD_Cmd(LCD_FIRST_ROW  + col - 1);
     break;
    case 2:
      LCD_Cmd(LCD_SECOND_ROW + col - 1);
      break;
    case 3:
      LCD_Cmd(LCD_THIRD_ROW  + col - 1);
      break;
    case 4:
      LCD_Cmd(LCD_FOURTH_ROW + col - 1);
      break;
    //default:     
  }

}
//**********************************************************************
//**********************************************************************
//**********************************************************************
//**********************************************************************
void LCD_Cmd(uint8_t Command)
{
  RS = 0;
  LCD_Write_Nibble(Command >> 4);
  LCD_Write_Nibble(Command);
  if((Command == LCD_CLEAR) || (Command == LCD_RETURN_HOME))
    __delay_ms(2);
}
//**********************************************************************
//**********************************************************************

//**********************************************************************
//**********************************************************************
void LCD_Begin()
{
  RS = 0;

  LCD_RS     = 0;
  LCD_EN     = 0;
  LCD_D4     = 0;
  LCD_D5     = 0;
  LCD_D6     = 0;
  LCD_D7     = 0;
  LCD_RS_DIR = 0;
  LCD_EN_DIR = 0;
  LCD_D4_DIR = 0;
  LCD_D5_DIR = 0;
  LCD_D6_DIR = 0;
  LCD_D7_DIR = 0;

  __delay_ms(40);
  LCD_Cmd(3);
  __delay_ms(5);
  LCD_Cmd(3);
  __delay_ms(5);
  LCD_Cmd(3);
  __delay_ms(5);
  LCD_Cmd(LCD_RETURN_HOME);
  __delay_ms(5);
  LCD_Cmd(0x20 | (LCD_TYPE << 2));
  __delay_ms(50);
  LCD_Cmd(LCD_TURN_ON);
  __delay_ms(50);
  LCD_Cmd(LCD_CLEAR);
  __delay_ms(50);
  LCD_Cmd(LCD_ENTRY_MODE_SET | LCD_RETURN_HOME);
  __delay_ms(50);
}

//**********************************************************************
//*************BME280***************************************************
//*************BME280***************************************************
//**********************************************************************


// BME280
typedef enum
{
  MODE_SLEEP  = 0x00,  // sleep mode
  MODE_FORCED = 0x01,  // forced mode
  MODE_NORMAL = 0x03   // normal mode
} bme280_mode;


typedef enum
{
  SAMPLING_SKIPPED = 0x00,  
  SAMPLING_X1      = 0x01,  // oversampling x1
  SAMPLING_X2      = 0x02,  // oversampling x2
  SAMPLING_X4      = 0x03,  // oversampling x4
  SAMPLING_X8      = 0x04,  // oversampling x8
  SAMPLING_X16     = 0x05   // oversampling x16
} bme280_sampling;

typedef enum
{
  FILTER_OFF = 0x00,  // filter off
  FILTER_2   = 0x01,  // filter coefficient = 2
  FILTER_4   = 0x02,  // filter coefficient = 4
  FILTER_8   = 0x03,  // filter coefficient = 8
  FILTER_16  = 0x04   // filter coefficient = 16
} bme280_filter;


typedef enum
{
  STANDBY_0_5   =  0x00,  // standby time = 0.5 ms
  STANDBY_62_5  =  0x01,  // standby time = 62.5 ms
  STANDBY_125   =  0x02,  // standby time = 125 ms
  STANDBY_250   =  0x03,  // standby time = 250 ms
  STANDBY_500   =  0x04,  // standby time = 500 ms
  STANDBY_1000  =  0x05,  // standby time = 1000 ms
  STANDBY_10    =  0x06,  // standby time = 10 ms
  STANDBY_20    =  0x07   // standby time = 20 ms
} standby_time;

struct
{
  uint16_t dig_T1;
  int16_t  dig_T2;
  int16_t  dig_T3;
  uint16_t dig_P1;
  int16_t  dig_P2;
  int16_t  dig_P3;
  int16_t  dig_P4;
  int16_t  dig_P5;
  int16_t  dig_P6;
  int16_t  dig_P7;
  int16_t  dig_P8;
  int16_t  dig_P9;

  uint8_t  dig_H1;
  int16_t  dig_H2;
  uint8_t  dig_H3;
  int16_t  dig_H4;
  int16_t  dig_H5;
  int8_t   dig_H6;
} BME280_calib;

void BME280_Write8(uint8_t reg_addr, uint8_t _data)
{
  BME280_Start();
  BME280_Write(BME280_I2C_ADDRESS);
  BME280_Write(reg_addr);
  BME280_Write(_data);
  BME280_Stop();
}

uint8_t BME280_Read8(uint8_t reg_addr)
{
  uint8_t ret;
  
  BME280_Start();
  BME280_Write(BME280_I2C_ADDRESS);
  BME280_Write(reg_addr);
  BME280_StartR();
  BME280_Write(BME280_I2C_ADDRESS | 1);
  ret = BME280_Read(0);
  BME280_Stop();

  return ret;
}

// reads 16 bits 
uint16_t BME280_Read16(uint8_t reg_addr)
{
  union
  {
    uint8_t  b[2];
    uint16_t w;
  } ret;

  BME280_Start();
  BME280_Write(BME280_I2C_ADDRESS);
  BME280_Write(reg_addr);
  BME280_StartR();
  BME280_Write(BME280_I2C_ADDRESS | 1);
  ret.b[0] = BME280_Read(1);
  ret.b[1] = BME280_Read(0);
  BME280_Stop();

  return(ret.w);
}

// BME280 sensor configuration
void BME280_Configure(bme280_mode mode, bme280_sampling T_sampling, bme280_sampling H_sampling,
                      bme280_sampling P_sampling, bme280_filter filter, standby_time standby)
{
  uint8_t _ctrl_hum, _ctrl_meas, _config;

  _ctrl_hum = H_sampling;
  _config = ((standby << 5) | (filter << 2)) & 0xFC;
  _ctrl_meas = (T_sampling << 5) | (P_sampling << 2) | mode;
  
  BME280_Write8(BME280_REG_CTRLHUM, _ctrl_hum);
  BME280_Write8(BME280_REG_CONFIG,  _config);
  BME280_Write8(BME280_REG_CONTROL, _ctrl_meas);
}

// initializes the BME280 sensor, returns 1 if OK and 0 if error
uint8_t BME280_begin(bme280_mode mode,
                  bme280_sampling T_sampling,
                  bme280_sampling H_sampling,
                  bme280_sampling P_sampling,
                  bme280_filter filter,
                  standby_time  standby)
{
  if(BME280_Read8(BME280_REG_CHIPID) != BME280_CHIP_ID)
    return 0;

  // reset the BME280 with soft reset
  BME280_Write8(BME280_REG_SOFTRESET, 0xB6);
  __delay_ms(100);

  // if NVM data are being copied to image registers, wait 100 ms
  while( (BME280_Read8(BME280_REG_STATUS) & 0x01) == 0x01 )
    __delay_ms(100);

  BME280_calib.dig_T1 = BME280_Read16(BME280_REG_DIG_T1);
  BME280_calib.dig_T2 = BME280_Read16(BME280_REG_DIG_T2);
  BME280_calib.dig_T3 = BME280_Read16(BME280_REG_DIG_T3);

  BME280_calib.dig_P1 = BME280_Read16(BME280_REG_DIG_P1);
  BME280_calib.dig_P2 = BME280_Read16(BME280_REG_DIG_P2);
  BME280_calib.dig_P3 = BME280_Read16(BME280_REG_DIG_P3);
  BME280_calib.dig_P4 = BME280_Read16(BME280_REG_DIG_P4);
  BME280_calib.dig_P5 = BME280_Read16(BME280_REG_DIG_P5);
  BME280_calib.dig_P6 = BME280_Read16(BME280_REG_DIG_P6);
  BME280_calib.dig_P7 = BME280_Read16(BME280_REG_DIG_P7);
  BME280_calib.dig_P8 = BME280_Read16(BME280_REG_DIG_P8);
  BME280_calib.dig_P9 = BME280_Read16(BME280_REG_DIG_P9);

  BME280_calib.dig_H1 = BME280_Read8(BME280_REG_DIG_H1);
  BME280_calib.dig_H2 = BME280_Read16(BME280_REG_DIG_H2);
  BME280_calib.dig_H3 = BME280_Read8(BME280_REG_DIG_H3);
  BME280_calib.dig_H4 = ((uint16_t)BME280_Read8(BME280_REG_DIG_H4) << 4) | (BME280_Read8(BME280_REG_DIG_H4 + 1) & 0x0F);
  if (BME280_calib.dig_H4 & 0x0800)    // if BME280_calib.dig_H4 < 0
      BME280_calib.dig_H4 |= 0xF000;
  BME280_calib.dig_H5 = ((uint16_t)BME280_Read8(BME280_REG_DIG_H5 + 1) << 4) | (BME280_Read8(BME280_REG_DIG_H5) >> 4);
  if (BME280_calib.dig_H5 & 0x0800)    // if BME280_calib.dig_H5 < 0
      BME280_calib.dig_H5 |= 0xF000;
  BME280_calib.dig_H6 = BME280_Read8(BME280_REG_DIG_H6);

  BME280_Configure(mode, T_sampling, H_sampling, P_sampling, filter, standby);

  return 1;
}

// takes a new measurement, for forced mode only!
// Returns 1 if ok and 0 if error (sensor is not in sleep mode)
uint8_t BME280_ForcedMeasurement()
{
  uint8_t ctrl_meas_reg = BME280_Read8(BME280_REG_CONTROL);

  if ( (ctrl_meas_reg & 0x03) != 0x00 )
    return 0;   // sensor is not in sleep mode

  // set sensor to forced mode
  BME280_Write8(BME280_REG_CONTROL, ctrl_meas_reg | 1);
  // wait for conversion complete
  while (BME280_Read8(BME280_REG_STATUS) & 0x08)
    __delay_ms(1);

  return 1;
}

// read (updates) adc_P, adc_T and adc_H from BME280 sensor
void BME280_Update()
{
  union
  {
    uint8_t  b[4];
    uint32_t dw;
  } ret;
  ret.b[3] = 0x00;

  BME280_Start();
  BME280_Write(BME280_I2C_ADDRESS);
  BME280_Write(BME280_REG_PRESS_MSB);
  BME280_StartR();
  BME280_Write(BME280_I2C_ADDRESS | 1);
  ret.b[2] = BME280_Read(1);
  ret.b[1] = BME280_Read(1);
  ret.b[0] = BME280_Read(1);

  adc_P = (ret.dw >> 4) & 0xFFFFF;

  ret.b[2] = BME280_Read(1);
  ret.b[1] = BME280_Read(1);
  ret.b[0] = BME280_Read(1);

  adc_T = (ret.dw >> 4) & 0xFFFFF;

  ret.b[2] = 0x00;
  ret.b[1] = BME280_Read(1);
  ret.b[0] = BME280_Read(0);
  BME280_Stop();

  adc_H = ret.dw & 0xFFFF;
}

// Reads temperature from BME280.
// Temperature is stored in hundredths C (output value of "5123" equals 51.23 DegC).
// Temperature value is saved to *temp, returns 1 if OK and 0 if error.
uint8_t BME280_readTemperature(int32_t *temp)
{
  int32_t var1, var2;

  BME280_Update();

  // calculate temperature
  var1 = ((((adc_T / 8) - ((int32_t)BME280_calib.dig_T1 * 2))) *
         ((int32_t)BME280_calib.dig_T2)) / 2048;

  var2 = (((((adc_T / 16) - ((int32_t)BME280_calib.dig_T1)) *
         ((adc_T / 16) - ((int32_t)BME280_calib.dig_T1))) / 4096) *
         ((int32_t)BME280_calib.dig_T3)) / 16384;

  t_fine = var1 + var2;

  *temp = (t_fine * 5 + 128) / 256;

  return 1;
}

// Reads humidity from BME280 sensor.
// Humidity is stored in relative humidity percent in 1024 steps
// (output value of "47445" represents 47445/1024 = 46.333 %RH).
// Humidity value is saved to *humi, returns 1 if OK and 0 if error.
uint8_t BME280_readHumidity(uint32_t *humi)
{
  int32_t v_x1_u32r;
  uint32_t H;

  v_x1_u32r = (t_fine - ((int32_t)76800));

  v_x1_u32r = (((((adc_H * 16384) - (((int32_t)BME280_calib.dig_H4) * 1048576) - (((int32_t)BME280_calib.dig_H5) * v_x1_u32r)) +
      ((int32_t)16384)) / 32768) * (((((((v_x1_u32r * ((int32_t)BME280_calib.dig_H6)) / 1024) * (((v_x1_u32r *
      ((int32_t)BME280_calib.dig_H3)) / 2048) + ((int32_t)32768))) / 1024) + ((int32_t)2097152)) *
      ((int32_t)BME280_calib.dig_H2) + 8192) / 16384));
      
  v_x1_u32r = (v_x1_u32r - (((((v_x1_u32r / 32768) * (v_x1_u32r / 32768)) / 128) * ((int32_t)BME280_calib.dig_H1)) / 16));
  v_x1_u32r = (v_x1_u32r < 0 ? 0 : v_x1_u32r);
  v_x1_u32r = (v_x1_u32r > 419430400 ? 419430400 : v_x1_u32r);
   
  H = (uint32_t)(v_x1_u32r / 4096);
  *humi = H;

  return 1;
}

// Reads pressure from BME280 sensor.
// Pressure is stored in Pa (output value of "96386" equals 96386 Pa = 963.86 hPa).
// Pressure value is saved to *pres, returns 1 if OK and 0 if error.
uint8_t BME280_readPressure(uint32_t *pres)
{
  int32_t var1, var2;
  uint32_t p;

  // calculate pressure
  var1 = (((int32_t)t_fine) / 2) - (int32_t)64000;
  var2 = (((var1/4) * (var1/4)) / 2048 ) * ((int32_t)BME280_calib.dig_P6);

  var2 = var2 + ((var1 * ((int32_t)BME280_calib.dig_P5)) * 2);
  var2 = (var2/4) + (((int32_t)BME280_calib.dig_P4) * 65536);

  var1 = ((((int32_t)BME280_calib.dig_P3 * (((var1/4) * (var1/4)) / 8192 )) / 8) +
         ((((int32_t)BME280_calib.dig_P2) * var1)/2)) / 262144;

  var1 =((((32768 + var1)) * ((int32_t)BME280_calib.dig_P1)) / 32768);

  if (var1 == 0)
    return 0; // avoid exception caused by division by zero

  p = (((uint32_t)(((int32_t)1048576) - adc_P) - (var2 / 4096))) * 3125;

  if (p < 0x80000000)
    p = (p * 2) / ((uint32_t)var1);

  else
    p = (p / (uint32_t)var1) * 2;

  var1 = (((int32_t)BME280_calib.dig_P9) * ((int32_t)(((p/8) * (p/8)) / 8192))) / 4096;
  var2 = (((int32_t)(p/4)) * ((int32_t)BME280_calib.dig_P8)) / 8192;

  p = (uint32_t)((int32_t)p + ((var1 + var2 + (int32_t)BME280_calib.dig_P7) / 16));

  *pres = p;

  return 1;
}

// end of driver code.
//**********************************************************************
//*************BME280***************************************************
//*************BME280***************************************************

//**********************************************************************
//*************DS18B20**************************************************
//**********************************************************************
__bit ds18b20_start()
{
  DS18B20_PIN = 0;      // send reset pulse DS18B20 
  DS18B20_PIN_Dir = 0;  // DS18B20_PIN pin output
  __delay_us(500);      //  500 us
 
  DS18B20_PIN_Dir = 1;  // DS18B20_PIN pin input
  __delay_us(100);      // wait 100 us to read the DS18B20 sensor response
 
  if (!DS18B20_PIN)
  {
    __delay_us(400);    // wait 400 us
    return 1;           // DS18B20 sensor is present
  }
 
  return 0;   // connection error
}
 
void ds18b20_write_bit(uint8_t value)
{
  DS18B20_PIN = 0;
  DS18B20_PIN_Dir = 0;  // configure DS18B20_PIN pin as output
  __delay_us(2);        // wait 2 us
 
  DS18B20_PIN = (__bit)value;
  __delay_us(80);       // wait 80 us
 
  DS18B20_PIN_Dir = 1;  // configure DS18B20_PIN pin as input
  __delay_us(2);        // wait 2 us
}
 
void ds18b20_write_byte(uint8_t value)
{
  for(uint8_t i = 0; i < 8; i++)
    ds18b20_write_bit(value >> i);
}
 
__bit ds18b20_read_bit(void)
{
  static __bit value;
 
  DS18B20_PIN = 0;
  DS18B20_PIN_Dir = 0;  // configure DS18B20_PIN pin as output
  __delay_us(2);
 
  DS18B20_PIN_Dir = 1;  // configure DS18B20_PIN pin as input
  __delay_us(5);        // wait 5 us
 
  value = DS18B20_PIN;  // read and store DS18B20 state
  __delay_us(100);      // wait 100 us
 
  return value;
}
 
uint8_t ds18b20_read_byte(void)
{
  uint8_t value = 0;
 
  for(uint8_t i = 0; i < 8; i++)
    value |= ds18b20_read_bit() << i;
 
  return value;
}
 
__bit ds18b20_read(uint16_t *raw_temp_value)
{
  if (!ds18b20_start())   // send start pulse
    return 0;             // return 0 if error
 
  ds18b20_write_byte(0xCC);   // send skip ROM command
  ds18b20_write_byte(0x44);   // send start conversion command
 
  while(ds18b20_read_byte() == 0);  // wait for conversion complete
 
  if (!ds18b20_start())  // send start pulse
    return 0;            // return 0 if error
 
  ds18b20_write_byte(0xCC);  // send skip ROM command
  ds18b20_write_byte(0xBE);  // send read command
 
  // read temperatureD LSB byte and store it on raw_temp_value LSB byte
  *raw_temp_value  = ds18b20_read_byte();
  // read temperatureD MSB byte and store it on raw_temp_value MSB byte
  *raw_temp_value |= (uint16_t)(ds18b20_read_byte() << 8);
 
  return 1;   // OK --> return 1
}

//**********************************************************************
//*************DS18B20**************************************************
//**********************************************************************

//**********************************************************************
//**************DHT22***************************************************
// send start signal to the sensor
void Start_Signal(void) {
  DHT22_PIN_DIR = 0;     // configure DHT22_PIN as output
  DHT22_PIN = 0;         // clear DHT22_PIN output (logic 0)
 
  __delay_ms(25);        // wait 25 ms
  DHT22_PIN = 1;         // set DHT22_PIN output (logic 1)
 
  __delay_us(30);        // wait 30 us
  DHT22_PIN_DIR = 1;     // configure DHT22_PIN as input
}
 
// Check sensor response
__bit Check_Response() {
  TMR1H = 0;                 // reset Timer1
  TMR1L = 0;
  TMR1ON = 1;                // enable Timer1 module
 
  while(!DHT22_PIN && TMR1L < 100);  // wait until DHT22_PIN becomes high (checking of 80s low time response)
 
  if(TMR1L > 99)                     // if response time > 99S  ==> Response error
    return 0;                        // return 0 (Device has a problem with response)
 
  else
  {
    TMR1H = 0;               // reset Timer1
    TMR1L = 0;
 
    while(DHT22_PIN && TMR1L < 100); // wait until DHT22_PIN becomes low (checking of 80s high time response)
 
    if(TMR1L > 99)                   // if response time > 99S  ==> Response error
      return 0;                      // return 0 (Device has a problem with response)
 
    else
      return 1;                      // return 1 (response OK)
  }
}
 
// Data read function
__bit Read_Data(unsigned char* dht_data)
{
  *dht_data = 0;
 
  for(char i = 0; i < 8; i++)
  {
    TMR1H = 0;             // reset Timer1
    TMR1L = 0;
 
    while(!DHT22_PIN)      // wait until DHT22_PIN becomes high
      if(TMR1L > 100) {    // if low time > 100  ==>  Time out error (Normally it takes 50s)
        return 1;
      }
 
    TMR1H = 0;             // reset Timer1
    TMR1L = 0;
 
    while(DHT22_PIN)       // wait until DHT22_PIN becomes low
      if(TMR1L > 100) {    // if high time > 100  ==>  Time out error (Normally it takes 26-28s for 0 and 70s for 1)
        return 1;          // return 1 (timeout error)
      }
 
     if(TMR1L > 50)                  // if high time > 50  ==>  Sensor sent 1
       *dht_data |= (1 << (7 - i));  // set bit (7 - i)
  }
 
  return 0;                          // return 0 (data read OK)
}
//**************DHT22***************************************************
//**********************************************************************

//**************************************************************
//**************************************************************
/*************************** main function *********************/
void main(void)
{
  nRBPU = 0;  //  R (0-, 1-)
  ADCON1=0x06;   //    "" . 0000  0110
  I2C_Init(400000);   // initialize I2C bus with clock frequency of 400kHz

  T1CON  = 0x10;        // set Timer1 clock source to internal with 1:2 prescaler (Timer1 clock = 1MHz)
  TMR1H  = 0;           // reset Timer1
  TMR1L  = 0;
  __delay_ms(100);   // 
 
  LCD_Begin();        // initialize LCD module
  __delay_ms(100);   // 
  LCD_Cmd(LCD_CLEAR);

  LCD_Goto(1, 1);
  LCD_Print(buffer);
 
  if(BME280_begin(MODE_NORMAL, SAMPLING_X1, SAMPLING_X1, SAMPLING_X1, FILTER_OFF, STANDBY_0_5) == 0)
  { 
    LCD_Cmd(LCD_CLEAR);
    LCD_Goto(1, 3);
    LCD_Print("O\xAC\xA5\xA0\x4B\x41 COE\xE0\xA5\x48\x45\x48\xA5\xB1");
    LCD_Goto(1, 4);
    LCD_Print("BME280");
                 }

  __delay_ms(4000);
  LCD_Cmd(LCD_CLEAR);

  while(1)
  {
 
    BME280_readTemperature(&temperature);  // read temperature
    BME280_readHumidity(&humidity);        // read humidity
    BME280_readPressure(&pressure);        // read pressure
    
    if(temperature < 0)
      sprintf(buffer, "-%02u.%02u%cC", (unsigned int)(abs(temperature)/100), (unsigned int)(abs(temperature)%100), 223);
    else
      sprintf(buffer, " %02u.%02u%cC", (unsigned int)(temperature/100), (unsigned int)(temperature%100), 223);

  LCD_Goto(13, 4);
  LCD_Print(buffer);

   pressurem = pressure;
   pressure = pressure / 133.322;
   sprintf(buffer, "ATM \xE0\x41\x42 %03u mmH", (unsigned int)(pressure));
  LCD_Goto(1, 3);
  LCD_Print(buffer);


    sprintf(buffer, "\x42\xA7\x41\xA3 %02u.%02u %%", (unsigned int)(humidity/1024), (unsigned int)(((humidity*100)/1024)%100));

  LCD_Goto(1, 4);
  LCD_Print(buffer);
    
//**********************************************************************
//*************DS18B20**************************************************
    if(ds18b20_read(&raw_temp))
    {
      if(raw_temp & 0x8000)  // if the temperatureD is negative
      {
        tempD[6] = '-';             // put minus sign (-)
        raw_temp = (~raw_temp) + 1;  // change temperatureD value to positive form
      }
 
      else
      {
        if((raw_temp >> 4) >= 100)  // if the temperatureD >= 100 C
          tempD[6] = '1';            // put 1 of hundreds
        else                        // otherwise
          tempD[6] = ' ';            // put space ' '
      }
 
      // put the first two digits ( for tens and ones)
      tempD[7] = ( (raw_temp >> 4) / 10 ) % 10 + '0';  // put tens digit
      tempD[8] =   (raw_temp >> 4)        % 10 + '0';  // put ones digit
 
      tempD[10] = ( (raw_temp & 0x0F) * 625) / 1000 + '0';          // put thousands digit
      tempD[11] = (((raw_temp & 0x0F) * 625) / 100 ) % 10 + '0';    // put hundreds digit
      tempD[12] = (((raw_temp & 0x0F) * 625) / 10 )  % 10 + '0';    // put tens digit
      tempD[13] = ( (raw_temp & 0x0F) * 625) % 10 + '0';            // put ones digit
      tempD[14] = 223;   // put degree symbol (  )
 
      LCD_Goto(1, 1);     // move cursor
      LCD_Print(tempD);    // print tempD
    }
 
    else
    {
      LCD_Goto(1, 1);          //   DS18B20
      LCD_Print("O\xAC\xA5\xA0\x4B\x41 DS18B20      ");
    }
//*************DS18B20************************************************** 
//**********************************************************************

//**********************************************************************
//**************DHT22***************************************************
    Start_Signal();     // send start signal to the sensor
 
    if(Check_Response())    // check if there is a response from sensor (If OK start reading humidityH and temperatureH data)
    {
      // read (and save) data from the DHT22 sensor and check time out errors
      if(Read_Data(&RH_Byte1) || Read_Data(&RH_Byte2) || Read_Data(&T_Byte1) || Read_Data(&T_Byte2) || Read_Data(&CheckSum))
      {
        //LCD_Cmd(LCD_CLEAR);       // clear LCD
        LCD_Goto(1, 2);           // 
        LCD_Print("Time out!           ");   // display "Time out!"
      }
 
      else         // if there is no time out error
      {
        if(CheckSum == ((RH_Byte1 + RH_Byte2 + T_Byte1 + T_Byte2) & 0xFF))
        {                                       // if there is no checksum error
          RH = RH_Byte1;
          RH = (RH << 8) | RH_Byte2;
          TempH = T_Byte1;
          TempH = (TempH << 8) | T_Byte2;
 
          if (TempH > 0X8000)
          {                         // if temperatureH < 0
            TemperatureH[2] = '-';   // put minus sign '-'
            TempH = TempH & 0X7FFF;
          }
          else                     // otherwise (temperatureH > 0)

          if ((TempH / 10) >= 100)
          {                         //
            TemperatureH[2] = '1';  //
          }
          else   
          {
           TemperatureH[2] = ' ';  // put space ' '
          }

          TemperatureH[3]  = (TempH / 100) % 10  + '0';
          TemperatureH[4]  = (TempH / 10) % 10   + '0';
          TemperatureH[6] =  TempH % 10  + '0';
          TemperatureH[7] = 223;    // put degree symbol ()
 
          if(RH == 1000)              // if the relative humidityH = 100.0 %
            HumidityH[5]  = 1 + '0';   // put 1 of hundreds
          else
            HumidityH[5]  = ' ';       // put space ' '
          HumidityH[6]  = (RH / 100) % 10 + '0';
          HumidityH[7]  = (RH / 10) % 10  + '0';
          HumidityH[9] = RH % 10 + '0';

          LCD_Goto(12, 2);           // go to column
          LCD_Print(TemperatureH);

          LCD_Goto(1, 2);           // go to column
          LCD_Print(HumidityH);

        }
 
        //   
        else
        {
          LCD_Goto(1, 2);           // go to column
          LCD_Print("O\xAC\xA5\xA0\x4B\x41 K C\xA9\x4D\x4D\xAE!     ");
        }
 
      }
    }
 
    //  
    else
    {
      LCD_Goto(1, 2);           //  DHT22
      LCD_Print("O\xAC\xA5\xA0\x4B\x41 DHT22        ");
    }
 
    TMR1ON = 0;        // disable Timer1 module
//**************DHT22***************************************************
//**********************************************************************
    __delay_ms(1000);  // wait 2 seconds

  }
 
}
 
/*************************** end main function ********************************/

/********************** I2C functions **************************/

void I2C_Init(uint32_t i2c_clk_freq)
{
  SSPCON  = 0x28;  // configure MSSP module to work in I2C mode
  SSPADD  = (_XTAL_FREQ/(4 * i2c_clk_freq)) - 1;  // set I2C clock frequency
  SSPSTAT = 0;
  TRISC3 = 1;
  TRISC4 = 1;
}

//***************************************************************** 
//***************************************************************** 
void I2C_Wait()
{
    while ((SSPSTAT & 0x04) || (SSPCON2 & 0x1F));  // wait for MSSP module to be free (not busy)
}
//***************************************************************** 
//***************************************************************** 

void I2C_Start()
{
  I2C_Wait();
  SEN = 1;  // initiate start condition
}
 
void I2C_Repeated_Start()
{
  I2C_Wait();
  RSEN = 1;  // initiate repeated start condition
}
 
void I2C_Stop()
{
  I2C_Wait();
  PEN = 1;  // initiate stop condition
}
 
void I2C_Write(uint8_t i2c_data)
{
  I2C_Wait();
  SSPBUF = i2c_data;  // update buffer
}
 
uint8_t I2C_Read(uint8_t ack)
{
  uint8_t _data;
  I2C_Wait();
  RCEN = 1;
  I2C_Wait();
  _data = SSPBUF;  // read data from buffer
  I2C_Wait();
  ACKDT = !ack;
  ACKEN = 1;
  return _data;  // return data read
}
 
/********************** end I2C functions **********************/

